<template>
    <div id="gridexpviewgridexpbar" class="app-grid-exp-bar">
        <div class='grid-exp-bar-header'>
            <div class="grid-exp-bar-title">
                <icon type='ios-home-outline'/>我是标题
            </div>
        </div>
        <div class="exp-bar-action-container">
            <div class="quick-group-container">
                <app-quick-group :items="quickGroupModel"  @valuechange="quickGroupValueChange"></app-quick-group>
            </div>
            <div class='search-container'>
                <i-input
                    v-model="searchText"
                    :search="true"
                    :placeholder="placeholder"
                    @on-search="onSearch">
                </i-input>
            </div>
                <div class='toolbar-container'>
    <tooltip :transfer="true" :max-width="600">
            <i-button v-show="gridexpviewgridexpbar_toolbarModels.deuiaction3.visabled" :disabled="gridexpviewgridexpbar_toolbarModels.deuiaction3.disabled" class='' v-button-loading:i-button @click="gridexpbar_toolbar_click({ tag: 'deuiaction3' }, $event)">
                <i class='fa fa-edit'></i>
                <span class='caption'>{{'编辑'}}</span>
            </i-button>
        <div slot='content'>{{$t('TBB.TEXT.*.EDIT', '编辑')}}</div>
    </tooltip>
</div>
        </div>
            <div class='grid-exp-bar-content'>
                <view_gridexpbar_grid 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context"
    :pViewCtx="viewCtx"
    :isSingleSelect="isSingleSelect"
    :showBusyIndicator="true"
    updateAction=""
    removeAction="Remove"
    loaddraftAction=""
    loadAction=""
    createAction=""
    fetchAction="FetchDefault"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="gridexpbar_grid"  
    ref='gridexpbar_grid' 
    @selectionchange="gridexpbar_grid_selectionchange($event)"  
    @load="gridexpbar_grid_load($event)"  
    @closeview="closeView($event)">
</view_gridexpbar_grid>
            </div>
    </div>
</template>
// 基于 @CONTROL/表格导航/CONTROL-BASE.vue.ftl 生成

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZOrderEntityService from '@/service/ibizorder/ibizorder-service';
import GridExpViewgridexpbarService from './grid-exp-viewgridexpbar-gridexpbar-service';
import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';
import CodeListService from "@/codelist/codelist-service";


@Component({
    components: {
      
    }
})
export default class GridExpViewgridexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数(父级)
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public pViewCtx!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public viewCtx: any = {};

    /**
     * 监听视图操作参数变化
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Watch('pViewCtx', { immediate: true })
    public onViewCtxChange(newVal: any, oldVal: any) {
        Object.assign(this.viewCtx, newVal, { xData: this, ctrl: this });
    }

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof GridExpViewgridexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public getControlType(): string {
        return 'GRIDEXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof GridExpViewgridexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {GridExpViewgridexpbarService}
     * @memberof GridExpViewgridexpbarBase
     */
    public service: GridExpViewgridexpbarService = new GridExpViewgridexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof GridExpViewgridexpbarBase
     */
    public appEntityService: IBIZOrderEntityService = new IBIZOrderEntityService({ $store: this.$store });

    /**
     * gridexpbar_grid 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_grid_selectionchange($event: any, $event2?: any) {
        this.gridexpbar_selectionchange($event, 'gridexpbar_grid', $event2);
    }

    /**
     * gridexpbar_grid 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_grid_load($event: any, $event2?: any) {
        this.gridexpbar_load($event, 'gridexpbar_grid', $event2);
    }

    /**
     * gridexpbar_toolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_toolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction3')) {
            this.gridexpbar_toolbar_deuiaction3_click(null, 'gridexpbar_toolbar', $event2);
        }
    }
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public gridexpbar_toolbar_deuiaction3_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this.$refs.gridexpbar_grid;
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = [...xData.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Edit(datas, contextJO,paramJO,  $event, xData,this,"IBIZOrder");
    }

    /**
     * 编辑
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZOrderGridExpViewBase
     */
    public Edit(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        if (args.length === 0) {
            return;
        }
        const _this: any = this;
        if (_this.opendata && _this.opendata instanceof Function) {
            const data: any = { };
            if (args.length > 0) {
                Object.assign(data, { ibizorder: args[0].ibizorder })
            }
            _this.opendata([{ ...data }], args, params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'opendata 视图处理逻辑不存在，请添加!' });
        }
    }

    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  GridExpViewgridexpbarBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof GridExpViewgridexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        Object.assign(actionData, args);
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }





    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 视图唯一标识
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof GridExpViewgridexpbarBase
     */
    public isSingleSelect:boolean = true;


    /**
     * 可搜索字段名称
     * 
     * 
     * @type {(string)}
     * @memberof GridExpViewgridexpbarBase
     */
    public placeholder = "订单名称";

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof GridExpViewgridexpbarBase
     */
    public searchText: string = "";


    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navViewName: string = "ibizorder-detail-grid-view9";

    /**
     * 导航过滤项
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navFilter: string = "ibizordername";

    /**
     * 导航关系
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navPSDer: string = "n_ibizorderid_eq";
    
    /**
     * 导航上下文参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public navigateContext:any ={CTXPARAM2:"%orderstate%",CTXPARAM1:"xxx2"};

    /**
     * 导航视图参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public navigateParams:any = {param2:"%ibizordername%",param1:"param3"}; 
    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof IBIZOrderGridExpViewBase
     */  
    public codeListService:CodeListService = new CodeListService();
    
    /**
     * 快速分组数据对象
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public quickGroupData:any;

    /**
     * 快速分组是否有抛值
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public isEmitQuickGroupValue:boolean = false;

    /**
     * 快速分组模型
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public quickGroupModel:Array<any> = [];

    /**
     * 加载快速分组模型
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public loadQuickGroupModel(){
        let quickGroupCodeList:any = {tag:'OrderType',codelistType:'STATIC'};
        if(quickGroupCodeList.tag && Object.is(quickGroupCodeList.codelistType,"STATIC")){
            const codelist = this.$store.getters.getCodeList(quickGroupCodeList.tag);
            if (codelist) {
                this.quickGroupModel = [...this.handleDynamicData(JSON.parse(JSON.stringify(codelist.items)))];
            } else {
                console.log(`----${quickGroupCodeList.tag}----代码表不存在`);
            }
        }else if(quickGroupCodeList.tag && Object.is(quickGroupCodeList.codelistType,"DYNAMIC")){
            this.codeListService.getItems(quickGroupCodeList.tag,{},{}).then((res:any) => {
                this.quickGroupModel = res;
            }).catch((error:any) => {
                console.log(`----${quickGroupCodeList.tag}----代码表不存在`);
            });
        }
    }

    /**
     * 处理快速分组模型动态数据部分(%xxx%)
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public handleDynamicData(inputArray:Array<any>){
        if(inputArray.length >0){
            inputArray.forEach((item:any) =>{
               if(item.data && Object.keys(item.data).length >0){
                   Object.keys(item.data).forEach((name:any) =>{
                        let value: any = item.data[name];
                        if (value && typeof(value)=='string' && value.startsWith('%') && value.endsWith('%')) {
                            const key = (value.substring(1, value.length - 1)).toLowerCase();
                            if (this.context[key]) {
                                value = this.context[key];
                            } else if(this.viewparams[key]){
                                value = this.viewparams[key];
                            }
                        }
                        item.data[name] = value;
                   })
               }
            })
        }
        return inputArray;
    }

    /**
     * 快速分组值变化
     *
     * @memberof IBIZOrderGridExpViewBase
     */
    public quickGroupValueChange($event:any){
        if($event && $event.data){
            if(this.quickGroupData) {
                for(let key in this.quickGroupData) {
                    delete this.viewparams[key];
                }
            }
            this.quickGroupData = $event.data;
            Object.assign(this.viewparams, $event.data);
        }else{
            if(this.quickGroupData) {
                for(let key in this.quickGroupData) {
                    delete this.viewparams[key];
                }
            }
        }
        if(this.isEmitQuickGroupValue){
            this.onSearch($event);
        }
        this.isEmitQuickGroupValue = true;
    }

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof MOBILEENTITY3Canlen
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


        /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZOrderGridExpView
     */
    public gridexpviewgridexpbar_toolbarModels: any = {
        deuiaction3: { name: 'deuiaction3', actiontarget: 'NONE', caption: '编辑', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Edit', target: 'SINGLEKEY' } },

    };


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof GridExpViewgridexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public created() {
        this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public afterCreated(){
        this.loadQuickGroupModel();
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'gridexpbar_grid', action: action, data: data });
            });
        } 
    }

    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public afterMounted() { }

    /**
     * vue 生命周期
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
    * 执行搜索
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public onSearch($event:any) {
        let grid:any = this.$refs.gridexpbar_grid;
        grid.load({ query: this.searchText });
        
    }

    /**
    * 刷新
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.gridexpbar_grid) {
            refs.gridexpbar_grid.refresh();
        }
    }

    /**
     * gridexpbar的选中数据事件
     * 
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        const tempContext: any = {};
        const tempViewParam: any = {};
        if (args.length === 0) {
            this.calcToolbarItemState(true);
            return ;
        }
        const arg: any = args[0];
        if (this.context) {
            Object.assign(tempContext, JSON.parse(JSON.stringify(this.context)));
        }
        Object.assign(tempContext, { 'ibizorder': arg['ibizorder']});
        Object.assign(tempContext, { srfparentdename: 'IBIZOrder', srfparentkey:arg['ibizorder']});
        if (this.navFilter && !Object.is(this.navFilter, "")) {
            Object.assign(tempViewParam, { [this.navFilter]: arg['ibizorder']});
        }
        if (this.navPSDer && !Object.is(this.navPSDer,"")) {
            Object.assign(tempViewParam, { [this.navPSDer]: arg['ibizorder']});
        }
        if (this.navigateContext && Object.keys(this.navigateContext).length > 0) {
            let _context:any = this.$util.computedNavData(arg, tempContext, tempViewParam, this.navigateContext);
            Object.assign(tempContext, _context);
        }
        if (this.navigateParams && Object.keys(this.navigateParams).length > 0) {
            let _params:any = this.$util.computedNavData(arg, tempContext, tempViewParam, this.navigateParams);
            Object.assign(tempViewParam, _params);
        }
        const navItem: any = {
            navView: this.navViewName,
            data: args,
            srfnavdata: {
                context: tempContext,
                viewparams: tempViewParam
            }
        }
        this.handleCtrlEvents('onselectionchange', { data: args }).then((res: boolean) => {
            if (!res) {
                this.calcToolbarItemState(true);
                return;
            }
            this.calcToolbarItemState(false);
            this.$emit('selectionchange', navItem);
        })
    }

    /**
     * gridexpbar的load完成事件
     * 
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_load(args:any, tag?: string, $event2?: any){
        this.calcToolbarItemState(true);
        this.$emit('load',args);
    }
    
    /**
     * 设置导航区工具栏禁用状态
     *
     * @param {boolean} state
     * @return {*} 
     * @memberof GridExpViewgridexpbarBase
     */
    public calcToolbarItemState(state: boolean) {
        let _this: any = this;
        const models:any = _this.gridexpviewgridexpbar_toolbarModels;
        if (models) {
            for (const key in models) {
                if (!models.hasOwnProperty(key)) {
                    return;
                }
                const _item = models[key];
                if (_item.uiaction && (Object.is(_item.uiaction.target, 'SINGLEKEY') || Object.is(_item.uiaction.target, 'MULTIKEY'))) {
                    _item.disabled = state;
                }
                _item.visabled = true;
                if (_item.noprivdisplaymode && _item.noprivdisplaymode === 6) {
                    _item.visabled = false;
                }
            }
            this.calcNavigationToolbarState();
        }
    }   

    /**
     * 计算导航工具栏权限状态
     * 
     * @memberof GridExpViewgridexpbarBase
     */
    public calcNavigationToolbarState(){
        let _this: any = this;
        // 界面行为
        if(_this.gridexpviewgridexpbar_toolbarModels){
            const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
            ViewTool.calcActionItemAuthState({},_this.gridexpviewgridexpbar_toolbarModels,curUIService);
        }
    }
}
</script>

<style lang='less'>
@import './grid-exp-viewgridexpbar-gridexpbar.less';
</style>